import React from "react";
import { UseFormixReturnType } from "../core/hooks";
import type { FormSchema, FormSchemaBase, FormSchemaSymbol, ConvertFieldToFormPrimitiveValue } from "../core/types";
export declare const Formix: <T extends FormSchemaBase>(props: Props<T> & {
    ref?: React.ForwardedRef<HTMLFormElement> | undefined;
}) => JSX.Element;
export interface Props<T extends FormSchemaBase> extends Omit<React.ComponentProps<"form">, "onSubmit"> {
    schema: T | FormSchema<T>;
    children: (formix: Omit<UseFormixReturnType<T>, "Form" | "bindForm">) => React.ReactNode;
    onSubmit?: (values: {
        [K in keyof FormSchema<T>[FormSchemaSymbol]["fields"]]: ConvertFieldToFormPrimitiveValue<FormSchema<T>[FormSchemaSymbol]["fields"][K]>;
    }) => void;
}
