import React from "react";
import type { AliasBase, ValidateFn, FormSchema, StoreSchema, FieldSchema, FormSchemaBase, StoreSchemaBase, FieldSchemaBase, FormValuePrimitive, FormElementPrimitive } from "./types";
export declare function formSchema<T extends FormSchemaBase>(schema: FormSchema<T> | T): FormSchema<T>;
export declare function field<T extends FormValuePrimitive>(schema: FieldSchema<T> | FieldSchemaBase<T>): FieldSchema<T>;
export declare function storeSchema<S extends StoreSchemaBase>(object: S): StoreSchema<S>;
export declare function validateFactory<T extends any[]>(validateFn: (...args: T) => ValidateFn): (...args: T) => ValidateFn;
export declare function validationChain(...args: ValidateFn[]): ValidateFn;
declare type FieldProps<T extends AliasBase, K extends keyof T> = {
    as: K;
} & (T[K] extends React.FC<infer R> ? R : {});
export declare function fieldFactory<T extends AliasBase>(alias: T): <K extends keyof T>(props: FieldProps<T, K> & {
    ref?: React.ForwardedRef<any>;
}) => JSX.Element;
export declare function fieldFactory<T extends AliasBase, D extends keyof T>(alias: T, def: D): <K extends keyof T = D>(props: Omit<FieldProps<T, K>, "as"> & Partial<Pick<FieldProps<T, K>, "as">> & {
    ref?: React.ForwardedRef<any>;
}) => JSX.Element;
export declare function syncFieldsValues(fields: FormElementPrimitive[], value: FormValuePrimitive): void;
export declare function collectFieldsValues(field: FormElementPrimitive, value: FormValuePrimitive): string | boolean | string[];
export declare function isFieldSchema(object: any): object is FieldSchema<any>;
export declare function isFieldValuePrimitive(object: any): object is FormValuePrimitive;
export {};
